unit Setup;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, DToolBar;

type
  TSetupDlg = class(TForm)
    OKBtn: TBitBtn;
    Filepanel: TPanel;
    Buttons: TGroupBox;
    SpeedButton3: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton16: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure SpeedButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ButtonsDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure ButtonsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SetBeginDrag(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    NewBtn : TSpeedButton;
  public
    { Public declarations }
  end;

var
  SetupDlg: TSetupDlg;

implementation

{$R *.DFM}

procedure TSetupDlg.SpeedButton1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  { Speedbutton1.Down := True; }
   TSpeedButton(Sender).BeginDrag(false);
end;

procedure TSetupDlg.FormCreate(Sender: TObject);
begin
 SetWindowPos(SetupDlg.Handle, HWND_TOPMOST, SetupDlg.Left, SetupDlg.Top,
              SetupDlg.width,SetupDlg.Height, SWP_NOACTIVATE);
end;

procedure TSetupDlg.ButtonsDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := Source is TSpeedButton;
end;

procedure TSetupDlg.FormShow(Sender: TObject);
begin
  Setfocus;
end;

procedure TSetupDlg.OKBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TSetupDlg.ButtonsDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
{  TSpeedButton(Source).Visible:=false;}
    if (TSpeedButton(Source).Parent is TDToolbar) then
    begin
      TSpeedButton(Source).Parent.RemoveControl(TSpeedButton(Source));
      TDToolbar(Sender).Insertcontrol(TSpeedButton(Source));
      if (TDToolbar(Sender).DockStatus = dsTop) or
         (TDToolbar(Sender).DockStatus = dsTop) then
        TSpeedbutton(Source).Left := X
      else
        TSpeedbutton(Source).Top  := Y;
    end;
  if (Sender is TPanel) and (Source is TSpeedButton) then
  begin
{    NewBtn := TSpeedButton.Create(self);
    NewBtn.Parent:= TPanel(Sender);
    NewBtn.Glyph.Assign(TSpeedbutton(Source).Glyph);
    NewBtn.NumGlyphs := 2;
    NewBtn.OnMouseDown := SetBeginDrag;}
  end;

end;

procedure TSetupDlg.SetBeginDrag(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  TSpeedButton(Sender).begindrag(false);
end;

end.
